%option noyywrap
%option caseless

%{
#include <stdio.h>
#include <cjson/cJSON.h>


#include "calc.tab.h"
extern YYSTYPE yylval;

#define cp_yylval_and_return(x) \
    yylval.sv = (char*)malloc(strlen(yytext) + 1); \
    strcpy(yylval.sv, yytext); \
    return x;
%}

%%

[ \t\n]	;
[0-9]+\.[0-9]+ 	{yylval.fv = atof(yytext); return FLOAT;}
[0-9]+		    {yylval.iv = atoi(yytext); return INT;}


"CREATE"	{return CREATE;}
"INSERT"	{return INSERT;}
"INTO"		{return INTO;}
"SELECT"	{return SELECT;}
"FROM"		{return FROM;}
"WHERE"		{return WHERE;}
"VALUES"	{return VALUES;}
"DELETE"	{return DELETE;}
"UPDATE"	{return UPDATE;}
"SET"		{return SET;}
"JOIN"      {return JOIN;}
"TABLE"		{return TABLE;}

"INT"       {cp_yylval_and_return(INT);}
"FLOAT"     {cp_yylval_and_return(FLOAT);}
"STRING"    {cp_yylval_and_return(STRING);}


;		    {return NEWLINE;}

[*]			return *yytext;
[,]			return *yytext;
[=]			return *yytext;
[<]			return *yytext;
[>]			return *yytext;
[(]         return *yytext;
[)]         return *yytext;

"primary key"	{cp_yylval_and_return(PRIMARY_KEY);}

"quit"		{return QUIT;}

[a-zA-Z][a-zA-Z0-9]*	cp_yylval_and_return(IDENTIFIER);


%%
